/*============================================================================
	File:		0030 - SQL Server - Configuration.sql

	Summary:	This script demonstrates how to...
				- get information of current configuration
				- get information about a dedicated configuration setting
				- reconfigure configuration options

	Date:		September 2023

	SQL Server Version: >= 2016
------------------------------------------------------------------------------
	Written by Uwe Ricken, db Berater GmbH

	This script is intended only as a supplement to demos and lectures
	given by Uwe Ricken.  
  
	THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF 
	ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED 
	TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
	PARTICULAR PURPOSE.
============================================================================*/
USE master;
GO

/*
	To get a list of all configuration options you can use sys.configurations!
*/
SELECT	configuration_id,
        name,
        value,
        minimum,
        maximum,
        value_in_use,
        description,
        is_dynamic,
        is_advanced
FROM	sys.configurations;
GO

EXEC sp_configure;

/*
	To get the configuration information of one dedicated value you can use
	sp_configure!
*/
EXEC sp_configure N'backup compression default';
GO

/*
	Some configurations are not visible by default (advanced)
*/
EXEC sp_configure N'max degree of parallelism';
GO

EXEC sp_configure N'show advanced options', 1;
RECONFIGURE WITH OVERRIDE;
GO

EXEC sp_configure N'max degree of parallelism';
GO

/*
	To configure a value just set the new value as second parameter
*/
EXEC sp_configure N'max degree of parallelism', 0;
RECONFIGURE WITH OVERRIDE;
GO

EXEC sp_configure N'max degree of parallelism';
GO

EXEC sp_configure N'show advanced options', 0;
RECONFIGURE WITH OVERRIDE;
GO
